%{
open Lexing
open Parsing
open Format

let syntax_error msg =
  let p = symbol_start_pos () in
  raise (Syntaxerr.Syntax_error (p, msg))

let expecting n s =
  let p = rhs_start_pos n in
  raise (Syntaxerr.Syntax_error
    (p, sprintf "Syntax error:  %s expected." s))
%}

%token <string> IDENT
%token LPAREN RPAREN EOF

%type <string * string list list> yices

%start yices

%%

yices:
  | IDENT tuples EOF { ($1, $2) }

tuples:
  | tuple tuples { $1 :: $2 }
  |              { [] }

tuple:
  | LPAREN ident_list RPAREN { $2 }

ident_list:
  | IDENT ident_list { $1 :: $2 }
  |                  { [] }
